=== debian/changelog ===
simutrans (123.0.1-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:00:52 +1100

simutrans (123.0.1-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:14:27 +0000

simutrans (123.0.1-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Markus Koschany <apo@debian.org>  Fri, 16 Jun 2023 01:03:47 +0200

simutrans (123.0.1-2) experimental; urgency=medium

  [ Jörg Frings-Fürst ]
  * Build verbosely by default (Closes: #1032414).
    Thanks to Helmut Grohne <helmut@subdivi.de>

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 11 Mar 2023 17:53:36 +0100

simutrans (123.0.1-1) unstable; urgency=medium

  [ Jörg Frings-Fürst ]
  * New upstream release (Closes: #1020687):
    - New debian/patches/0010-build.patch.
    - New debian/patches/0100-workingdir.patch.
    - Refresh patches.
    - Remove not longer used patsches:
      + debian/patches/0100-path_for_game-data.patch
      + debian/patches/0505-link-less-libraries.diff
      + debian/patches/0510-missing_uncommon_mk.patch
      + debian/patches/sha1.patch
    - Update translations.
    - Convert translations to utf-8.
  * debian/control:
    - Add new Build-Depends.
    - Move Depends version of simutrans-pak64 to 121.0.
  * Declare compliance with Debian Policy 4.6.2.0 (No changes needed).
  * debian/copyright:
    - Add year 2023 to myself.
  * debian/rules:
    - Fix FTCBFS: Use the host architecture pkg-config (Closes: #993124).
      Thanks to Helmut Grohne <helmut@subdivi.de>.

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 18 Feb 2023 17:30:51 +0100
